/* 
   Figment - a Gtk2 based outliner.  

   Copyright 2002 Matthew Allum

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ifndef _HAVE_EXPORT_H
#define _HAVE_EXPORT_H

#include "figment.h"

enum {
  EXPORT_TEXT,
  EXPORT_HTML,
  EXPORT_DOCBOOK,
  EXPORT_RDF
};

typedef struct _exporter
{
  FILE *fh;

  void (*start_item_cb) (
			 struct _exporter *exporter,
			 gchar *thought_data, 
			 gboolean is_checked,
			 gboolean is_expanded,
			 void  *userdata 
			 );
  void (*end_item_cb) (
		       struct _exporter *exporter,
		       gchar *thought_data, 
		       gboolean is_checked,
		       gboolean is_expanded,
		       void  *userdata 
		       );

  void (*start_branch_cb) (  struct _exporter *exporter, void  *userdata  );
  void (*end_branch_cb) (  struct _exporter *exporter, void  *userdata  );
  void (*header_cb) (  struct _exporter *exporter, void  *userdata  );
  void (*footer_cb) (  struct _exporter *exporter, void  *userdata  );
  
  gint depth;

  void *userdata;

} Exporter;

int export_html(char *filename);
int export_text(char *filename);
int export_docbook(char *filename);
int export_rtf(char *filename);


#endif 




