/* 
   Figment - a Gtk2 based outliner.  

   Copyright 2002 Matthew Allum

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ifndef HAVE_FIGMENT_H
#define HAVE_FIGMENT_H

#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <libintl.h>
#include <locale.h>
#include "opml.h"
#include "export.h"
#include "util.h"

#define CONF_FILE ".figment"

enum
{
  MENU_OP_EXPAND = 1,
  MENU_OP_EXPAND_SUBS,
  MENU_OP_EXPAND_ALL,
  MENU_OP_COLLAPSE,
  MENU_OP_COLLAPSE_ALL,
  MENU_OP_COLLAPSE_PAR,
  MENU_OP_MOVE_NEXT_CHLD,
  MENU_OP_MOVE_NEXT_SIB,
  MENU_OP_MOVE_PREV_CHLD,
  MENU_OP_MOVE_PREV_SIB,
  MENU_OP_ADD_CHLD,
  MENU_OP_ADD_SIB,
  MENU_OP_PROMOTE,
  MENU_OP_DEMOTE,
  MENU_OP_RAISE,
  MENU_OP_LOWER,
  MENU_OP_COL_BLUE,
  MENU_OP_FILE_SAVE,
  MENU_OP_FILE_SAVE_AS,
  MENU_OP_FILE_NEW,
  MENU_OP_FILE_OPEN,
  MENU_OP_FILE_REVERT,
  MENU_OP_EXPORT_HTML,
  MENU_OP_EXPORT_RTF,
  MENU_OP_EXPORT_DOCBOOK,
  MENU_OP_EXPORT_TEXT

};

typedef struct figment 
{
  GtkWidget *window;
  GtkWidget *treeview;
  GtkWidget *toolbar;

  gchar     *filename;
  gboolean  disk_sync;
  gchar      *lasterror;

  gboolean     render_toplevel_pretty;
  gboolean     render_colors;
  gboolean     show_toolbar;
  gboolean     open_last;

} Figment;

/* TreeItem structure */
typedef struct _TreeItem TreeItem;
struct _TreeItem
{
  const gchar    *thought;
  gboolean        checked;
  gboolean        editable;
  TreeItem       *children;
};

/* columns */
enum
{
  MARKUP_COLUMN = 0,
  CHECKED_COLUMN,
  THOUGHT_COLUMN,
  EDITABLE_COLUMN,
  NUM_COLUMNS
};

void figment_set_cell_text(GtkTreeIter *iter, gchar *text);


#endif 
